main()
{
	//maps\mp\mp_mario_fx::main();
	//maps\createart\mp_mario_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_mario");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_mario" );
	ambientPlay("ambient_factory_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level.fx_birds = loadfx("misc/bird_takeoff");
	level.fx_splash = loadfx("explosions/grenadeexp_water");

	//waterfall code
	waterfall = getent("waterfall","targetname");
	waterfall.b = getent(waterfall.target, "targetname");
	waterfall.c = getent(waterfall.b.target, "targetname");
	waterfall.d = getent(waterfall.c.target, "targetname");
	waterfall notSolid();
	waterfall.b notSolid();
	waterfall.c notSolid();
	waterfall.d notSolid();
	waterfall hide();
	waterfall.b hide();
	waterfall.c hide();
	waterfall.d hide();
	waterfall thread waterfall_animation();
	waterfall thread waterfall_sound();

	//water_tread_bottom code
	water_tread_bottom = getent("water_tread_bottom","targetname");
	water_tread_bottom thread water_tread_bottom_bob();

	//cannon code
	trig_cannon = getent("trig_cannon","targetname");
	trig_cannon.a = getent("cannonpath","targetname");
	trig_cannon.b = getent(trig_cannon.a.target,"targetname");
	trig_cannon.c = getent(trig_cannon.b.target,"targetname");
	trig_cannon.d = getent(trig_cannon.c.target,"targetname");
	trig_cannon.e = getent(trig_cannon.d.target,"targetname");
	trig_cannon.f = getent(trig_cannon.e.target,"targetname");
	trig_cannon.g = getent(trig_cannon.f.target,"targetname");
	trig_cannon.h = getent(trig_cannon.g.target,"targetname");
	trig_cannon thread cannon();

	//bird code
	trig_bird = getentarray("trig_bird","targetname");
	for(i=0;i<trig_bird.size;i++)
	{
		trig_bird[i].tree = getent(trig_bird[i].target,"targetname");
		trig_bird[i].fx_played = false;
		trig_bird[i] thread bird_startle();
	}

	//flag code
	flag = getentarray("flag","targetname");
	for(i=0;i<flag.size;i++)
	{
		flag[i].b = getent(flag[i].target,"targetname");
		flag[i].c = getent(flag[i].b.target,"targetname");
		flag[i].d = getent(flag[i].c.target,"targetname");
		flag[i].e = getent(flag[i].d.target,"targetname");
		flag[i] thread flag_flap();
	}

	//water code
	trig_water_under = getent("water_under","targetname");
	trig_water_surface = getent("water_surface","targetname");
	trig_water_under thread water_under();
	trig_water_surface thread water_surface();

	//grass code
	grass = getent("grass","targetname");
	grass notSolid();

	//pipe code
	pipe = getentarray("pipe", "targetname");
	for(i=0;i<pipe.size;i++)
	{
		pipe[i].pipe_a_trigger = getent(pipe[i].target,"targetname");
		pipe[i].pipe_a_mover = getent(pipe[i].pipe_a_trigger.target,"targetname");
		pipe[i].pipe_a_below = getent(pipe[i].pipe_a_mover.target,"targetname");
		pipe[i].pipe_b_below = getent(pipe[i].pipe_a_below.target,"targetname");
		pipe[i].pipe_b_trigger = getent(pipe[i].pipe_b_below.target,"targetname");
		pipe[i].pipe_b_mover = getent(pipe[i].pipe_b_trigger.target,"targetname");
		pipe[i].used = false;
		pipe[i].height = 80;
		pipe[i].time = 0.5;
		pipe[i] thread pipe_a();
		pipe[i] thread pipe_b();		
	}
}

//pipe code
pipe_a()
{
	while (1)
	{
		self.pipe_a_trigger waittill("trigger", user);
		if (!self.used)
		{
			self.used = true;
			if (user getstance() == "crouch")
			{
				user playsound("smb_pipe");
				self.pipe_a_mover moveto (user.origin, 0.1);
				self.pipe_a_mover waittill("movedone");
				self.pipe_a_mover.angles = user.angles;
				user linkto (self.pipe_a_mover);
				self.pipe_a_mover moveto (self.pipe_a_trigger.origin, self.time);
				self.pipe_a_mover waittill("movedone");
				self.pipe_a_mover movez(-1 * self.height, self.time);
				self.pipe_a_mover waittill("movedone");
				user unlink();
				user setorigin(self.pipe_a_below.origin);
				wait(0.1);
				user setorigin(self.pipe_b_below.origin);
				wait(0.1);
				user setorigin(self.pipe_b_trigger.origin - (0, 0, self.height));
				user linkto (self.pipe_a_mover);
				self.pipe_a_mover movez(self.height, self.time);
				self.pipe_a_mover waittill("movedone");
				user playsound("smb_pipe");
				user unlink();
				wait(3);
			}
			self.used = false;
		}
		wait(0.01);
	}
}
pipe_b()
{
	while (1)
	{
		self.pipe_b_trigger waittill("trigger", user);
		if (!self.used)
		{
			self.used = true;
			if (user getstance() == "crouch")
			{
				user playsound("smb_pipe");
				self.pipe_b_mover moveto (user.origin, 0.1);
				self.pipe_b_mover waittill("movedone");
				self.pipe_b_mover.angles = user.angles;
				user linkto (self.pipe_b_mover);
				self.pipe_b_mover moveto (self.pipe_b_trigger.origin, self.time);
				self.pipe_b_mover waittill("movedone");
				self.pipe_b_mover movez(-1 * self.height, self.time);
				self.pipe_b_mover waittill("movedone");
				user unlink();
				user setorigin(self.pipe_b_below.origin);
				wait(0.1);
				user setorigin(self.pipe_a_below.origin);
				wait(0.1);
				user setorigin(self.pipe_a_trigger.origin - (0, 0, self.height));
				user linkto (self.pipe_b_mover);
				self.pipe_b_mover movez(self.height, self.time);
				self.pipe_b_mover waittill("movedone");
				user playsound("smb_pipe");
				user unlink();
				wait(3);
			}
			self.used = false;
		}
		wait(0.01);
	}
}

//water_under code
water_under()
{
	while (1)
	{
		self waittill("trigger", user);
		user.water_under_exit_count = 0;	
		if (!isdefined(user.under_in))
		{
			user.under_in = false;
		}
		if (!user.under_in)
		{
			user.under_in = true;
			self thread water_under_exit_count_loop(user);
			self thread water_under_enter(user);
		}
	}
}

water_under_enter(user)
{
}

water_under_exit(user)
{
}

water_under_exit_count_loop(user)
{
	while (user.water_under_exit_count < 3)
	{
		user.water_under_exit_count++;
		if (user.under_in && !user.surface_in)
		{
			user.water_under_count++;
			if (user.water_under_count > user.water_hurt_wait * 10)
			{
				user.water_under_count = user.water_hurt_wait * 10;
				RadiusDamage(user.origin, 1, 2, 2);
			}
		}
		wait(0.1);
	}
	user.under_in = false;
	self thread water_under_exit(user);
}


//water_surface code
water_surface()
{
	while (1)
	{
		self waittill("trigger", user);
		user.water_surface_exit_count = 0;	
		if (!isdefined(user.surface_in))
		{
			user.surface_in = false;
			user.under_in = false;
			user.water_under_count = 0;
			user.water_hurt_wait = 5;
		}
		if (!user.surface_in)
		{
			user.surface_in = true;
			self thread water_surface_exit_count_loop(user);
			self thread water_surface_enter(user);
		}
	}
}

water_surface_enter(user)
{
	user.water_under_count = 0;
	user.water_under_exit_count = 0;
	if (!user.under_in)
	{
		PlayFX(level.fx_splash, user.origin);
	}
	user playsound("watersplash");
	user stoplocalsound("waterbackground");
}

water_surface_exit(user)
{
	if (user.under_in)
	{
		user playlocalsound("waterbackground");
	}
}

water_surface_exit_count_loop(user)
{
	while (user.water_surface_exit_count < 3)
	{
		user.water_surface_exit_count++;
		wait(0.1);
	}
	user.surface_in = false;
	self thread water_surface_exit(user);
}


//flag code
flag_flap()
{
	flag_distance = 20;
	flag_time = 1;
	d = Distance(self.origin, self.b.origin);
	while (true)
	{
		self rotateyaw(1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.b rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.b moveto(self.origin + (d * Cos(flag_distance), 1 * d * Sin(flag_distance), 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.c rotateyaw(1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.c moveto(self.origin + (2 * d * Cos(flag_distance), 0, 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.d rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.d moveto(self.origin + (3 * d * Cos(flag_distance), 1 * d * Sin(flag_distance), 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.e rotateyaw(1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.e moveto(self.origin + (4 * d * Cos(flag_distance), 0, 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self waittill ("rotatedone");
		
		self rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.b rotateyaw(1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.b moveto(self.origin + (d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.c rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.c moveto(self.origin + (2 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.d rotateyaw(1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.d moveto(self.origin + (3 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.e rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.e moveto(self.origin + (4 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self waittill ("rotatedone");

		self rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.b rotateyaw(1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.b moveto(self.origin + (d * Cos(flag_distance), -1 * d * Sin(flag_distance), 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.c rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.c moveto(self.origin + (2 * d * Cos(flag_distance), 0, 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.d rotateyaw(1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.d moveto(self.origin + (3 * d * Cos(flag_distance), -1 * d * Sin(flag_distance), 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.e rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self.e moveto(self.origin + (4 * d * Cos(flag_distance), 0, 0), 0.5 * flag_time, 0, 0.5 * flag_time / 2);
		self waittill ("rotatedone");

		self rotateyaw(1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.b rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.b moveto(self.origin + (d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.c rotateyaw(1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.c moveto(self.origin + (2 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.d rotateyaw(-1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.d moveto(self.origin + (3 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.e rotateyaw(1 * flag_distance, 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self.e moveto(self.origin + (4 * d, 0, 0), 0.5 * flag_time, 0.5 * flag_time / 2, 0);
		self waittill ("rotatedone");
	}
}

//bird code
bird_startle()
{
	while (1)
	{
		self waittill("trigger", user);
		bird_random = RandomInt(3);
		if (bird_random == 0)
		{
			self.tree playsound("bird1");
		}
		else if (bird_random == 1)
		{
			self.tree playsound("bird2");
		}
		else if (bird_random == 2)
		{
			if (!self.fx_played)
			{
				PlayFX(level.fx_birds, self.tree.origin);
				self.fx_played = true;
			}
			self.tree playsound("bird1");
		}		
		wait(60);
	}
}

//cannon code
cannon()
{
	cannon_time = 0.5;
	while (1)
	{
		self waittill("trigger", user);
		self playsound("cannon");
		user playlocalsound("cannon");
		air = spawn ("script_model",(0,0,0));
	        air.origin = user.origin;
		air.angles = user.angles;
		user linkto (air);
	        air moveto (self.b.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.c.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.d.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.e.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.f.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.g.origin, cannon_time);
		air waittill ("movedone");
	        air moveto (self.h.origin, cannon_time);
		air waittill ("movedone");
		user unlink();
		wait (0.1);
	}	
}

//water_tread_bottom code
water_tread_bottom_bob()
{
	water_tread_bottom_time = 1;
	water_tread_bottom_distance = 4;
	while (true)
	{
		self movez(water_tread_bottom_distance, water_tread_bottom_time, 0.5 * water_tread_bottom_time, 0.5 * water_tread_bottom_time);
		self waittill ("movedone");
		self movez(-1 * water_tread_bottom_distance, water_tread_bottom_time, 0.5 * water_tread_bottom_time, 0.5 * water_tread_bottom_time);
		self waittill ("movedone");
	}
}

//waterfall code
waterfall_animation()
{
	animation_time = 0.001;
	while (true)
	{	
		self show();
		wait(animation_time);
		self hide();
		self.b show();
		wait(animation_time);
		self.b hide();
		self.c show();
		wait(animation_time);
		self.c hide();
		self.d show();
		wait(animation_time);
		self.d hide();
	}
}

waterfall_sound()
{
	while (true)
	{	
		self playsound("waterfall");
		wait(1.5);
	}
}